describe("Control.Layers",(function(){var e;beforeEach((function(){e=L.map(document.createElement("div"))})),afterEach((function(){e.remove()})),describe("baselayerchange event",(function(){beforeEach((function(){e.setView([0,0],14)})),it("is fired on input that changes the base layer",(function(){var r={"Layer 1":L.tileLayer(""),"Layer 2":L.tileLayer("")},a=L.control.layers(r).addTo(e),t=sinon.spy();e.on("baselayerchange",t),happen.click(a._baseLayersList.getElementsByTagName("input")[0]),expect(t.called).to.be.ok(),expect(t.args[0][0].name).to.be("Layer 1"),expect(t.args[0][0].layer).to.be(r["Layer 1"]),happen.click(a._baseLayersList.getElementsByTagName("input")[1]),expect(t.calledTwice).to.be.ok(),expect(t.args[1][0].name).to.be("Layer 2"),expect(t.args[1][0].layer).to.be(r["Layer 2"])})),it("is not fired on input that doesn't change the base layer",(function(){var r={"Marker 1":L.marker([0,0]),"Marker 2":L.marker([0,0])},a=L.control.layers({},r).addTo(e),t=sinon.spy();e.on("baselayerchange",t),happen.click(a._overlaysList.getElementsByTagName("input")[0]),expect(t.called).to.not.be.ok()}))})),describe("updates",(function(){beforeEach((function(){e.setView([0,0],14)})),it("when an included layer is added or removed from the map",(function(){var r=L.tileLayer(),a=L.marker([0,0]),t=L.control.layers({Base:r},{Overlay:a}).addTo(e),o=sinon.spy(t,"_update");e.addLayer(a),e.removeLayer(a),expect(o.called).to.be.ok(),expect(o.callCount).to.eql(2)})),it("when an included layer is added or removed from the map, it's (un)checked",(function(){document.body.appendChild(e._container);var r=L.tileLayer(),a=L.marker([0,0]);L.control.layers({Baselayer:r},{Overlay:a}).addTo(e);function t(){return!!e._container.querySelector(".leaflet-control-layers-overlays input").checked}expect(t()).to.not.be.ok(),e.addLayer(a),expect(t()).to.be.ok(),e.removeLayer(a),expect(t()).to.not.be.ok()})),it("not when a non-included layer is added or removed",(function(){var r=L.tileLayer(),a=L.marker([0,0]),t=L.control.layers({Base:r}).addTo(e),o=sinon.spy(t,"_update");e.addLayer(a),e.removeLayer(a),expect(o.called).to.not.be.ok()})),it("updates when an included layer is removed from the control",(function(){document.body.appendChild(e._container);var r=L.tileLayer(),a=L.marker([0,0]);L.control.layers({Base:r},{Overlay:a}).addTo(e).removeLayer(a),expect(e._container.querySelector(".leaflet-control-layers-overlays").children.length).to.be.equal(0)})),it("silently returns when trying to remove a non-existing layer from the control",(function(){var r=L.control.layers({base:L.tileLayer()}).addTo(e);expect((function(){r.removeLayer(L.marker([0,0]))})).to.not.throwException(),expect(r._layers.length).to.be.equal(1)}))})),describe("is removed cleanly",(function(){beforeEach((function(){e.setView([0,0],14)})),it("and layers in the control can still be removed",(function(){var r=L.tileLayer("").addTo(e),a=L.control.layers({Base:r}).addTo(e);e.removeControl(a),expect((function(){e.removeLayer(r)})).to.not.throwException()}))})),describe("is created with an expand link",(function(){it("when collapsed",(function(){L.control.layers(null,null,{collapsed:!0}).addTo(e);expect(e._container.querySelector(".leaflet-control-layers-toggle")).to.be.ok()})),it("when not collapsed",(function(){L.control.layers(null,null,{collapsed:!1}).addTo(e);expect(e._container.querySelector(".leaflet-control-layers-toggle")).to.be.ok()}))})),describe("sortLayers",(function(){beforeEach((function(){e.setView([0,0],14)})),it("keeps original order by default",(function(){var r=L.tileLayer("").addTo(e),a=L.tileLayer("").addTo(e),t=L.marker([0,2]).addTo(e),o=L.marker([0,1]).addTo(e),n=L.marker([0,0]).addTo(e),l=(L.control.layers({"Base One":r,"Base Two":a},{"Marker C":t,"Marker B":o,"Marker A":n}).addTo(e),e.getContainer().querySelectorAll("div.leaflet-control-layers label span"));expect(l[0].innerHTML.trim()).to.be.equal("Base One"),expect(l[1].innerHTML.trim()).to.be.equal("Base Two"),expect(l[2].innerHTML.trim()).to.be.equal("Marker C"),expect(l[3].innerHTML.trim()).to.be.equal("Marker B"),expect(l[4].innerHTML.trim()).to.be.equal("Marker A")})),it("sorts alphabetically if no function is specified",(function(){var r=L.tileLayer("").addTo(e),a=L.tileLayer("").addTo(e),t=L.marker([0,0]).addTo(e),o=L.marker([0,1]).addTo(e),n=L.marker([0,2]).addTo(e),l=(L.control.layers({"Base Two":a,"Base One":r},{"Marker A":t,"Marker C":n,"Marker B":o},{sortLayers:!0}).addTo(e),e.getContainer().querySelectorAll("div.leaflet-control-layers label span"));expect(l[0].innerHTML.trim()).to.be.equal("Base One"),expect(l[1].innerHTML.trim()).to.be.equal("Base Two"),expect(l[2].innerHTML.trim()).to.be.equal("Marker A"),expect(l[3].innerHTML.trim()).to.be.equal("Marker B"),expect(l[4].innerHTML.trim()).to.be.equal("Marker C")})),it("uses the compare function to sort layers",(function(){var r=L.tileLayer("",{customOption:999}).addTo(e),a=L.tileLayer("",{customOption:998}).addTo(e),t=L.marker([0,0],{customOption:102}).addTo(e),o=L.marker([0,1],{customOption:100}).addTo(e),n=L.marker([0,2],{customOption:101}).addTo(e),l=(L.control.layers({"Base One":r,"Base Two":a},{"Marker A":t,"Marker B":o,"Marker C":n},{sortLayers:!0,sortFunction:function(e,r){return e.options.customOption-r.options.customOption}}).addTo(e),e.getContainer().querySelectorAll("div.leaflet-control-layers label span"));expect(l[0].innerHTML.trim()).to.be.equal("Base Two"),expect(l[1].innerHTML.trim()).to.be.equal("Base One"),expect(l[2].innerHTML.trim()).to.be.equal("Marker B"),expect(l[3].innerHTML.trim()).to.be.equal("Marker C"),expect(l[4].innerHTML.trim()).to.be.equal("Marker A")}))}))}));