describe("Events",(function(){describe("#fireEvent",(function(){it("fires all listeners added through #addEventListener",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy(),s=sinon.spy(),i=sinon.spy(),o=sinon.spy();sinon.spy();e.addEventListener("test",t),e.addEventListener("test",n),e.addEventListener("other",s),e.addEventListener({test:i,other:o}),expect(t.called).to.be(!1),expect(n.called).to.be(!1),expect(s.called).to.be(!1),expect(i.called).to.be(!1),expect(o.called).to.be(!1),e.fireEvent("test"),expect(t.called).to.be(!0),expect(n.called).to.be(!0),expect(s.called).to.be(!1),expect(i.called).to.be(!0),expect(o.called).to.be(!1)})),it("fires all listeners in the order they are added",(function(){var e=new L.Evented,t=new L.Class,n=new L.Class,s={one:0,two:0,three:0,four:0};function i(i){s.two++,expect(s.one).to.eql(1),expect(s.three).to.eql(0),1===s.two?expect(this).to.eql(n):2===s.two?expect(this).to.eql(t):expect(this).to.eql(e)}function o(e){s.three++,expect(s.two).to.eql(3),expect(s.four).to.eql(0),1===s.three?expect(this).to.eql(t):2===s.three&&expect(this).to.eql(n)}e.on("test",(function(e){s.one++,expect(s.two).to.eql(0)}),t),e.on("test",i,n),e.on("test",i,t),e.on("test",i),e.on("test",o,t),e.on("test",o,n),e.on("test",(function(e){s.four++,expect(s.three).to.eql(2)}),n),e.fireEvent("test"),expect(s.one).to.be(1),expect(s.two).to.be(3),expect(s.three).to.be(2),expect(s.four).to.be(1)})),it("provides event object to listeners and executes them in the right context",(function(){var e=new L.Evented,t=new L.Evented,n=new L.Evented,s=new L.Evented,i={};e.addEventListener("test",(function(t){expect(t.type).to.eql("test"),expect(t.target).to.eql(e),expect(this).to.eql(e),expect(t.baz).to.eql(1)})),t.addEventListener("test",(function(e){expect(e.type).to.eql("test"),expect(e.target).to.eql(t),expect(this).to.eql(i),expect(e.baz).to.eql(2)}),i),n.addEventListener({test:function(e){expect(e.type).to.eql("test"),expect(e.target).to.eql(n),expect(this).to.eql(n),expect(e.baz).to.eql(3)}}),s.addEventListener({test:function(e){expect(e.type).to.eql("test"),expect(e.target).to.eql(s),expect(this).to.eql(i),expect(e.baz).to.eql(4)}},i),e.fireEvent("test",{baz:1}),t.fireEvent("test",{baz:2}),n.fireEvent("test",{baz:3}),s.fireEvent("test",{baz:4})})),it("calls no listeners removed through #removeEventListener",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy(),s=sinon.spy(),i=sinon.spy(),o=sinon.spy();e.addEventListener("test",t),e.removeEventListener("test",t),e.fireEvent("test"),expect(t.called).to.be(!1),e.addEventListener("test2",n),e.addEventListener("test2",s),e.removeEventListener("test2"),e.fireEvent("test2"),expect(n.called).to.be(!1),expect(s.called).to.be(!1),e.addEventListener("test3",i),e.addEventListener("test4",o),e.removeEventListener({test3:i,test4:o}),e.fireEvent("test3"),e.fireEvent("test4"),expect(i.called).to.be(!1),expect(o.called).to.be(!1)})),it("can handle calls to #removeEventListener on objects with no registered event listeners",(function(){var e=new L.Evented;expect((function(){e.removeEventListener("test")})).to.not.throwException()})),it("fires multiple listeners with the same context with id",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy(),s={};L.Util.stamp(s),e.addEventListener("test",t,s),e.addEventListener("test",n,s),e.fireEvent("test"),expect(t.called).to.be(!0),expect(n.called).to.be(!0)})),it("removes listeners with stamped contexts",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy(),s={};L.Util.stamp(s),e.addEventListener("test",t,s),e.addEventListener("test",n,s),e.removeEventListener("test",t,s),e.fireEvent("test"),expect(t.called).to.be(!1),expect(n.called).to.be(!0)})),it("removes listeners with a stamp originally added without one",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy(),s={};e.addEventListener("test",t,s),L.Util.stamp(s),e.addEventListener("test",n,s),e.removeEventListener("test",t,s),e.removeEventListener("test",n,s),e.fireEvent("test"),expect(t.called).to.be(!1),expect(n.called).to.be(!1)})),it("removes listeners with context == this and a stamp originally added without one",(function(){var e=new L.Evented,t=new L.Evented,n=sinon.spy(),s=sinon.spy(),i=sinon.spy();e.addEventListener("test",n,e),L.Util.stamp(e),e.addEventListener("test",s,e),e.addEventListener("test",i,t),e.removeEventListener("test",n,e),e.removeEventListener("test",s,e),e.removeEventListener("test",i,t),e.fireEvent("test"),expect(n.called).to.be(!1),expect(s.called).to.be(!1),expect(i.called).to.be(!1)})),it("doesnt lose track of listeners when removing non existent ones",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy(),s={},i={};L.Util.stamp(s),L.Util.stamp(i),e.addEventListener("test",t,i),e.removeEventListener("test",t,s),e.removeEventListener("test",t,i),e.addEventListener("test",n,s),e.fireEvent("test"),expect(t.called).to.be(!1)})),it("correctly removes all listeners if given no fn",(function(){var e=new L.Evented,t=sinon.spy(),n={};e.addEventListener("test",t,n),e.addEventListener("test",t,{}),e.removeEventListener("test"),expect(e.listens("test")).to.be(!1),e.addEventListener("test",t,n),e.removeEventListener("test",t,n),expect(e.listens("test")).to.be(!1),e.addEventListener("test",t),e.removeEventListener("test",t),expect(e.listens("test")).to.be(!1)})),it("makes sure an event is not triggered if a listener is removed during dispatch",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy(),s=(sinon.spy(),{});e.addEventListener("test",(function(){e.removeEventListener("test",t)})),e.addEventListener("test",t),e.fireEvent("test"),expect(t.called).to.be(!1),e.addEventListener("test2",(function(){e.removeEventListener("test2",n,s)}),s),e.addEventListener("test2",n,s),e.fireEvent("test2")})),it("makes sure an event is not triggered if all listeners are removed during dispatch",(function(){var e=new L.Evented,t=sinon.spy();e.addEventListener("test",(function(){e.removeEventListener("test")})),e.addEventListener("test",t),e.fire("test"),expect(t.called).to.be(!1)})),it("handles reentrant event firing",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy();e.addEventListener("test1",(function(){e.fire("test2")})).addEventListener("test2",t).addEventListener("test1",(function(){e.removeEventListener("test1",n)})).addEventListener("test1",n),e.fireEvent("test1"),expect(t.called).to.be(!0),expect(n.called).to.be(!1)})),it("can remove an event listener while firing",(function(){var e=new L.Evented,t=sinon.spy(),n=function(){e.removeEventListener("test",t)};e.addEventListener("test",t),e.addEventListener("test",n),e.fire("test"),e.removeEventListener("test",n),expect(e.listens("test")).to.be(!1)}))})),describe("#on, #off & #fire",(function(){it("works like #addEventListener && #removeEventListener",(function(){var e=new L.Evented,t=sinon.spy();e.on("test",t),e.fire("test"),expect(t.called).to.be(!0),e.off("test",t),e.fireEvent("test"),expect(t.callCount).to.be.lessThan(2)})),it("does not override existing methods with the same name",(function(){var e=sinon.spy(),t=sinon.spy(),n=sinon.spy(),s=new(L.Evented.extend({on:e,off:t,fire:n}));s.on(),expect(e.called).to.be(!0),s.off(),expect(t.called).to.be(!0),s.fire(),expect(n.called).to.be(!0)})),it("does not add twice the same function",(function(){var e=new L.Evented,t=sinon.spy();e.on("test",t),e.on("test",t),e.fire("test"),expect(t.callCount).to.eql(1)}))})),describe("#clearEventListeners",(function(){it("clears all registered listeners on an object",(function(){var e=sinon.spy(),t=new L.Evented,n=new L.Evented;t.on("test",e,t),t.on("testTwo",e),t.on("test",e,n),t.off(),t.fire("test"),expect(e.called).to.be(!1)}))})),describe("#once",(function(){it("removes event listeners after first trigger",(function(){var e=new L.Evented,t=sinon.spy();e.once("test",t,e),e.fire("test"),expect(t.called).to.be(!0),e.fire("test"),expect(t.callCount).to.be.lessThan(2)})),it("works with an object hash",(function(){var e=new L.Evented,t=sinon.spy(),n=sinon.spy();e.once({test:t,otherTest:n},e),e.fire("test"),e.fire("otherTest"),expect(t.called).to.be(!0),expect(n.called).to.be(!0),e.fire("test"),e.fire("otherTest"),expect(t.callCount).to.be.lessThan(2),expect(n.callCount).to.be.lessThan(2)})),it("doesn't call listeners to events that have been removed",(function(){var e=new L.Evented,t=sinon.spy();e.once("test",t,e),e.off("test",t,e),e.fire("test"),expect(t.called).to.be(!1)})),it("works if called from a context that doesnt implement #Events",(function(){var e=new L.Evented,t=sinon.spy();e.once("test",t,{}),e.fire("test"),expect(t.called).to.be(!0)}))})),describe("addEventParent && removeEventParent",(function(){it("makes the object propagate events with to the given one if fired with propagate=true",(function(){var e=new L.Evented,t=new L.Evented,n=new L.Evented,s=sinon.spy(),i=sinon.spy();t.on("test",s),n.on("test",i),e.addEventParent(t).addEventParent(n),e.fire("test"),expect(s.called).to.be(!1),expect(i.called).to.be(!1),e.fire("test",null,!0),expect(s.called).to.be(!0),expect(i.called).to.be(!0),e.removeEventParent(t),e.fire("test",null,!0),expect(s.callCount).to.be(1),expect(i.callCount).to.be(2)})),it("can fire event where child has no listeners",(function(){var e=new L.Evented,t=new L.Evented,n=sinon.spy(),s=sinon.spy();e.on("test",n),t.on("test2",s),e.addEventParent(t),e.fire("test2",null,!0),expect(n.callCount).to.eql(0),expect(s.callCount).to.eql(1)}))})),describe("#listens",(function(){it("is false if there is no event handler",(function(){var e=new L.Evented;sinon.spy();expect(e.listens("test")).to.be(!1)})),it("is true if there is an event handler",(function(){var e=new L.Evented,t=sinon.spy();e.on("test",t),expect(e.listens("test")).to.be(!0)})),it("is false if event handler has been removed",(function(){var e=new L.Evented,t=sinon.spy();e.on("test",t),e.off("test",t),expect(e.listens("test")).to.be(!1)})),it('changes for a "once" handler',(function(){var e=new L.Evented,t=sinon.spy();e.once("test",t),expect(e.listens("test")).to.be(!0),e.fire("test"),expect(e.listens("test")).to.be(!1)}))}))}));