describe("Util",(function(){describe("#extend",(function(){var t;beforeEach((function(){t={foo:5,bar:"asd"}})),it("extends the first argument with the properties of the second",(function(){L.Util.extend(t,{bar:7,baz:3}),expect(t).to.eql({foo:5,bar:7,baz:3})})),it("accepts more than 2 arguments",(function(){L.Util.extend(t,{bar:7},{baz:3}),expect(t).to.eql({foo:5,bar:7,baz:3})}))})),describe("#bind",(function(){it("returns the given function with the given context",(function(){var t=L.Util.bind((function(){return this}),{foo:"bar"});expect(t()).to.eql({foo:"bar"})})),it("passes additional arguments to the bound function",(function(){var t=sinon.spy(),e={},o={},i={};L.Util.bind(t,{},e,o)(i),expect(t.calledWith(e,o,i)).to.be.ok()}))})),describe("#stamp",(function(){it("sets a unique id on the given object and returns it",(function(){var t={},e=L.Util.stamp(t);expect(typeof e).to.eql("number"),expect(L.Util.stamp(t)).to.eql(e);var o=L.Util.stamp({});expect(o).not.to.eql(e)}))})),describe("#falseFn",(function(){it("returns false",(function(){expect(L.Util.falseFn()).to.be(!1)}))})),describe("#formatNum",(function(){it("formats numbers with a given precision",(function(){expect(L.Util.formatNum(13.12325555,3)).to.eql(13.123),expect(L.Util.formatNum(13.12325555)).to.eql(13.12326)}))})),describe("#getParamString",(function(){it("creates a valid query string for appending depending on url input",(function(){var t="http://example.com/get",e={bar:7,baz:3},o="?bar=7&baz=3";expect(L.Util.getParamString(e,t)).to.eql(o);var i="http://example.com/get?justone=qs",n={bar:7,baz:3},a="&bar=7&baz=3";expect(L.Util.getParamString(n,i)).to.eql(a);var r={url:void 0,obj:{bar:7,baz:3},result:"?bar=7&baz=3"};expect(L.Util.getParamString(r.obj,r.url)).to.eql(r.result)}))})),describe("#requestAnimFrame",(function(){it("calles a function on next frame, unless canceled",(function(t){var e=sinon.spy(),o={};L.Util.requestAnimFrame(e),L.Util.requestAnimFrame((function(){expect(this).to.eql(o),t()}),o),L.Util.cancelAnimFrame(e)}))})),describe("#throttle",(function(){it("limits execution to not more often than specified time interval",(function(t){var e=sinon.spy(),o=L.Util.throttle(e,20);o(),o(),o(),expect(e.callCount).to.eql(1),setTimeout((function(){expect(e.callCount).to.eql(2),t()}),30)}))})),describe("#splitWords",(function(){it("splits words into an array",(function(){expect(L.Util.splitWords("foo bar baz")).to.eql(["foo","bar","baz"])}))})),describe("#setOptions",(function(){it("sets specified options on object",(function(){var t={};L.Util.setOptions(t,{foo:"bar"}),expect(t.options.foo).to.eql("bar")})),it("returns options",(function(){var t={},e=L.Util.setOptions(t,{foo:"bar"});expect(e).to.equal(t.options)})),it("accepts undefined",(function(){var t={};L.Util.setOptions(t,void 0),expect(t.options).to.eql({})})),it("creates a distinct options object",(function(){var t={},e=L.Util.create({options:t});L.Util.setOptions(e,{}),expect(e.options).not.to.equal(t)})),it("doesn't create a distinct options object if object already has own options",(function(){var t={},e={options:t};L.Util.setOptions(e,{}),expect(e.options).to.equal(t)})),it("inherits options prototypally",(function(){var t={},e=L.Util.create({options:t});L.Util.setOptions(e,{}),t.foo="bar",expect(e.options.foo).to.eql("bar")}))})),describe("#template",(function(){it("evaluates templates with a given data object",(function(){var t=L.Util.template("Hello {foo} and {bar}!",{foo:"Vlad",bar:"Dave"});expect(t).to.eql("Hello Vlad and Dave!")})),it("does not modify text without a token variable",(function(){expect(L.Util.template("foo",{})).to.eql("foo")})),it("supports templates with double quotes",(function(){expect(L.Util.template('He said: "{foo}"!',{foo:"Hello"})).to.eql('He said: "Hello"!')})),it("throws when a template token is not given",(function(){expect((function(){L.Util.template(void 0,{foo:"bar"})})).to.throwError()})),it("allows underscores and dashes in placeholders",(function(){expect(L.Util.template("{nice_stuff}",{nice_stuff:"foo"})).to.eql("foo"),expect(L.Util.template("{-y}",{"-y":1})).to.eql("1")}))})),describe("#isArray",(function(){expect(L.Util.isArray([1,2,3])).to.be(!0),expect(L.Util.isArray(new Array(1,2,3))).to.be(!0),expect(L.Util.isArray("blabla")).to.be(!1),expect(L.Util.isArray({0:1,1:2})).to.be(!1)}))}));