describe("CRS.EPSG3857",(function(){var e=L.CRS.EPSG3857;describe("#latLngToPoint",(function(){it("projects a center point",(function(){expect(e.latLngToPoint(L.latLng(0,0),0)).near(new L.Point(128,128),.01)})),it("projects the northeast corner of the world",(function(){expect(e.latLngToPoint(L.latLng(85.0511287798,180),0)).near(new L.Point(256,0))}))})),describe("#pointToLatLng",(function(){it("reprojects a center point",(function(){expect(e.pointToLatLng(new L.Point(128,128),0)).nearLatLng(L.latLng(0,0),.01)})),it("reprojects the northeast corner of the world",(function(){expect(e.pointToLatLng(new L.Point(256,0),0)).nearLatLng(L.latLng(85.0511287798,180))}))})),describe("project",(function(){it("projects geo coords into meter coords correctly",(function(){expect(e.project(new L.LatLng(50,30))).near(new L.Point(3339584.7238,6446275.84102)),expect(e.project(new L.LatLng(85.0511287798,180))).near(new L.Point(20037508.34279,20037508.34278)),expect(e.project(new L.LatLng(-85.0511287798,-180))).near(new L.Point(-20037508.34279,-20037508.34278))}))})),describe("unproject",(function(){it("unprojects meter coords into geo coords correctly",(function(){expect(e.unproject(new L.Point(3339584.7238,6446275.84102))).nearLatLng(new L.LatLng(50,30)),expect(e.unproject(new L.Point(20037508.34279,20037508.34278))).nearLatLng(new L.LatLng(85.051129,180)),expect(e.unproject(new L.Point(-20037508.34279,-20037508.34278))).nearLatLng(new L.LatLng(-85.051129,-180))}))})),describe("#getProjectedBounds",(function(){it("gives correct size",(function(){var t,n,o=256;for(t=0;t<=22;t++)n=e.getProjectedBounds(t).getSize(),expect(n.x).equal(o),expect(n.y).equal(o),o*=2}))})),describe("#wrapLatLng",(function(){it("wraps longitude to lie between -180 and 180 by default",(function(){expect(e.wrapLatLng(new L.LatLng(0,190)).lng).to.eql(-170),expect(e.wrapLatLng(new L.LatLng(0,360)).lng).to.eql(0),expect(e.wrapLatLng(new L.LatLng(0,380)).lng).to.eql(20),expect(e.wrapLatLng(new L.LatLng(0,-190)).lng).to.eql(170),expect(e.wrapLatLng(new L.LatLng(0,-360)).lng).to.eql(0),expect(e.wrapLatLng(new L.LatLng(0,-380)).lng).to.eql(-20),expect(e.wrapLatLng(new L.LatLng(0,90)).lng).to.eql(90),expect(e.wrapLatLng(new L.LatLng(0,180)).lng).to.eql(180)})),it("does not drop altitude",(function(){expect(e.wrapLatLng(new L.LatLng(0,190,1234)).lng).to.eql(-170),expect(e.wrapLatLng(new L.LatLng(0,190,1234)).alt).to.eql(1234),expect(e.wrapLatLng(new L.LatLng(0,380,1234)).lng).to.eql(20),expect(e.wrapLatLng(new L.LatLng(0,380,1234)).alt).to.eql(1234)}))}))})),describe("CRS.EPSG4326",(function(){var e=L.CRS.EPSG4326;describe("#getSize",(function(){it("gives correct size",(function(){var t,n,o=256;for(t=0;t<=22;t++)n=e.getProjectedBounds(t).getSize(),expect(n.x).equal(2*o),expect(n.y).equal(o),o*=2}))}))})),describe("CRS.EPSG3395",(function(){var e=L.CRS.EPSG3395;describe("#latLngToPoint",(function(){it("projects a center point",(function(){expect(e.latLngToPoint(L.latLng(0,0),0)).near(new L.Point(128,128),.01)})),it("projects the northeast corner of the world",(function(){expect(e.latLngToPoint(L.latLng(85.0840591556,180),0)).near(new L.Point(256,0))}))})),describe("#pointToLatLng",(function(){it("reprojects a center point",(function(){expect(e.pointToLatLng(new L.Point(128,128),0)).nearLatLng(L.latLng(0,0),.01)})),it("reprojects the northeast corner of the world",(function(){expect(e.pointToLatLng(new L.Point(256,0),0)).nearLatLng(L.latLng(85.0840591556,180))}))}))})),describe("CRS.Simple",(function(){var e=L.CRS.Simple;describe("#latLngToPoint",(function(){it("converts LatLng coords to pixels",(function(){expect(e.latLngToPoint(L.latLng(0,0),0)).near(new L.Point(0,0)),expect(e.latLngToPoint(L.latLng(700,300),0)).near(new L.Point(300,-700)),expect(e.latLngToPoint(L.latLng(-200,1e3),1)).near(new L.Point(2e3,400))}))})),describe("#pointToLatLng",(function(){it("converts pixels to LatLng coords",(function(){expect(e.pointToLatLng(L.point(0,0),0)).nearLatLng(new L.LatLng(0,0)),expect(e.pointToLatLng(L.point(300,-700),0)).nearLatLng(new L.LatLng(700,300)),expect(e.pointToLatLng(L.point(2e3,400),1)).nearLatLng(new L.LatLng(-200,1e3))}))})),describe("getProjectedBounds",(function(){it("returns nothing",(function(){expect(e.getProjectedBounds(5)).to.be(null)}))})),describe("wrapLatLng",(function(){it("returns coords as is",(function(){expect(e.wrapLatLng(new L.LatLng(270,400)).equals(new L.LatLng(270,400))).to.be(!0)})),it("wraps coords if configured",(function(){var e=L.extend({},L.CRS.Simple,{wrapLng:[-200,200],wrapLat:[-200,200]});expect(e.wrapLatLng(new L.LatLng(300,-250))).nearLatLng(new L.LatLng(-100,150))}))}))})),describe("CRS",(function(){var e=L.CRS;describe("#zoom && #scale",(function(){it("convert zoom to scale and viceversa and return the same values",(function(){var t=e.scale(2.5);expect(e.zoom(t)).to.eql(2.5)}))}))})),describe("CRS.ZoomNotPowerOfTwo",(function(){var e=L.extend({},L.CRS,{scale:function(e){return 256*Math.pow(1.5,e)},zoom:function(e){return Math.log(e/256)/Math.log(1.5)}});describe("#scale",(function(){it("of zoom levels are related by a power of 1.5",(function(){var t=e.scale(5);expect(e.scale(6)).to.eql(1.5*t),expect(e.zoom(1.5*t)).to.eql(6)}))})),describe("#zoom && #scale",(function(){it("convert zoom to scale and viceversa and return the same values",(function(){var t=e.scale(2);expect(e.zoom(t)).to.eql(2)}))}))})),describe("CRS.Earth",(function(){describe("#distance",(function(){var e=L.latLng(36.12,-86.67),t=L.latLng(33.94,-118.4);expect(L.CRS.Earth.distance(e,t)).to.be.within(2886444.43,2886444.45)}))}));