describe("LatLng",(function(){describe("constructor",(function(){it("sets lat and lng",(function(){var t=new L.LatLng(25,74);expect(t.lat).to.eql(25),expect(t.lng).to.eql(74);var e=new L.LatLng(-25,-74);expect(e.lat).to.eql(-25),expect(e.lng).to.eql(-74)})),it("throws an error if invalid lat or lng",(function(){expect((function(){new L.LatLng(NaN,NaN)})).to.throwError()})),it("does not set altitude if undefined",(function(){var t=new L.LatLng(25,74);expect(typeof t.alt).to.eql("undefined")})),it("sets altitude",(function(){var t=new L.LatLng(25,74,50);expect(t.alt).to.eql(50);var e=new L.LatLng(-25,-74,-50);expect(e.alt).to.eql(-50)}))})),describe("#equals",(function(){it("returns true if compared objects are equal within a certain margin",(function(){var t=new L.LatLng(10,20),e=new L.LatLng(10+1e-10,20-1e-10);expect(t.equals(e)).to.eql(!0)})),it("returns false if compared objects are not equal within a certain margin",(function(){var t=new L.LatLng(10,20),e=new L.LatLng(10,23.3);expect(t.equals(e)).to.eql(!1)})),it("returns false if passed non-valid object",(function(){var t=new L.LatLng(10,20);expect(t.equals(null)).to.eql(!1)}))})),describe("#toString",(function(){it("formats a string",(function(){var t=new L.LatLng(10.333333333,20.2222222);expect(t.toString(3)).to.eql("LatLng(10.333, 20.222)")}))})),describe("#distanceTo",(function(){it("calculates distance in meters",(function(){var t=new L.LatLng(50.5,30.5),e=new L.LatLng(50,1);expect(Math.abs(Math.round(t.distanceTo(e)/1e3)-2084)<5).to.eql(!0)})),it("does not return NaN if input points are equal",(function(){var t=new L.LatLng(50.5,30.5),e=new L.LatLng(50.5,30.5);expect(t.distanceTo(e)).to.eql(0)}))})),describe("L.latLng factory",(function(){it("returns LatLng instance as is",(function(){var t=new L.LatLng(50,30);expect(L.latLng(t)).to.eql(t)})),it("accepts an array of coordinates",(function(){expect(L.latLng([])).to.eql(null),expect(L.latLng([50])).to.eql(null),expect(L.latLng([50,30])).to.eql(new L.LatLng(50,30)),expect(L.latLng([50,30,100])).to.eql(new L.LatLng(50,30,100))})),it("passes null or undefined as is",(function(){expect(L.latLng(void 0)).to.eql(void 0),expect(L.latLng(null)).to.eql(null)})),it("creates a LatLng object from two coordinates",(function(){expect(L.latLng(50,30)).to.eql(new L.LatLng(50,30))})),it("accepts an object with lat/lng",(function(){expect(L.latLng({lat:50,lng:30})).to.eql(new L.LatLng(50,30))})),it("accepts an object with lat/lon",(function(){expect(L.latLng({lat:50,lon:30})).to.eql(new L.LatLng(50,30))})),it("returns null if lng not specified",(function(){expect(L.latLng(50)).to.be(null)})),it("accepts altitude as third parameter",(function(){expect(L.latLng(50,30,100)).to.eql(new L.LatLng(50,30,100))})),it("accepts an object with alt",(function(){expect(L.latLng({lat:50,lng:30,alt:100})).to.eql(new L.LatLng(50,30,100)),expect(L.latLng({lat:50,lon:30,alt:100})).to.eql(new L.LatLng(50,30,100))}))})),describe("#clone",(function(){it("should clone attributes",(function(){var t=new L.LatLng(50.5,30.5,100).clone();expect(t.lat).to.equal(50.5),expect(t.lng).to.equal(30.5),expect(t.alt).to.equal(100)})),it("should create another reference",(function(){var t=new L.LatLng(50.5,30.5,100),e=t.clone();expect(t===e).to.be(!1)}))}))}));