describe("L.GeoJSON",(function(){describe("addData",(function(){var e={type:"Feature",properties:{},geometry:{type:"Point",coordinates:[20,10,5]}},t={type:"Feature",properties:{},geometry:null};it("sets feature property on member layers",(function(){var t=new L.GeoJSON;t.addData(e),expect(t.getLayers()[0].feature).to.eql(e)})),it("normalizes a geometry to a Feature",(function(){var t=new L.GeoJSON;t.addData(e.geometry),expect(t.getLayers()[0].feature).to.eql(e)})),it("accepts geojson with null geometry",(function(){var e=new L.GeoJSON;e.addData(t),expect(e.getLayers().length).to.eql(0)}))})),describe("resetStyle",(function(){it("should reset init options",(function(){var e=L.geoJSON({type:"Feature",geometry:{type:"LineString",coordinates:[[-2.35,51.38],[-2.38,51.38]]}},{weight:7,color:"chocolate"});e.setStyle({weight:22,color:"coral"});var t=e.getLayers()[0];expect(t.options.weight).to.be(22),expect(t.options.color).to.be("coral"),e.resetStyle(t),expect(t.options.weight).to.be(7),expect(t.options.color).to.be("chocolate")}))}))})),describe("L.Marker#toGeoJSON",(function(){it("returns a 2D Point object",(function(){var e=new L.Marker([10,20]);expect(e.toGeoJSON().geometry).to.eql({type:"Point",coordinates:[20,10]})})),it("returns a 3D Point object",(function(){var e=new L.Marker([10,20,30]);expect(e.toGeoJSON().geometry).to.eql({type:"Point",coordinates:[20,10,30]})}))})),describe("L.Circle#toGeoJSON",(function(){it("returns a 2D Point object",(function(){var e=new L.Circle([10,20],100);expect(e.toGeoJSON().geometry).to.eql({type:"Point",coordinates:[20,10]})})),it("returns a 3D Point object",(function(){var e=new L.Circle([10,20,30],100);expect(e.toGeoJSON().geometry).to.eql({type:"Point",coordinates:[20,10,30]})}))})),describe("L.CircleMarker#toGeoJSON",(function(){it("returns a 2D Point object",(function(){var e=new L.CircleMarker([10,20]);expect(e.toGeoJSON().geometry).to.eql({type:"Point",coordinates:[20,10]})})),it("returns a 3D Point object",(function(){var e=new L.CircleMarker([10,20,30]);expect(e.toGeoJSON().geometry).to.eql({type:"Point",coordinates:[20,10,30]})}))})),describe("L.Polyline#toGeoJSON",(function(){it("returns a 2D LineString object",(function(){var e=new L.Polyline([[10,20],[2,5]]);expect(e.toGeoJSON().geometry).to.eql({type:"LineString",coordinates:[[20,10],[5,2]]})})),it("returns a 3D LineString object",(function(){var e=new L.Polyline([[10,20,30],[2,5,10]]);expect(e.toGeoJSON().geometry).to.eql({type:"LineString",coordinates:[[20,10,30],[5,2,10]]})}))})),describe("L.Polyline (multi) #toGeoJSON",(function(){it("returns a 2D MultiLineString object",(function(){var e=new L.Polyline([[[10,20],[2,5]],[[1,2],[3,4]]]);expect(e.toGeoJSON().geometry).to.eql({type:"MultiLineString",coordinates:[[[20,10],[5,2]],[[2,1],[4,3]]]})})),it("returns a 3D MultiLineString object",(function(){var e=new L.Polyline([[[10,20,30],[2,5,10]],[[1,2,3],[4,5,6]]]);expect(e.toGeoJSON().geometry).to.eql({type:"MultiLineString",coordinates:[[[20,10,30],[5,2,10]],[[2,1,3],[5,4,6]]]})}))})),describe("L.Polygon#toGeoJSON",(function(){it("returns a 2D Polygon object (no holes) from a flat LatLngs array",(function(){var e=new L.Polygon([[1,2],[3,4],[5,6]]);expect(e.toGeoJSON().geometry).to.eql({type:"Polygon",coordinates:[[[2,1],[4,3],[6,5],[2,1]]]})})),it("returns a 3D Polygon object (no holes) from a flat LatLngs array",(function(){var e=new L.Polygon([[1,2,3],[4,5,6],[7,8,9]]);expect(e.toGeoJSON().geometry).to.eql({type:"Polygon",coordinates:[[[2,1,3],[5,4,6],[8,7,9],[2,1,3]]]})})),it("returns a 2D Polygon object from a simple GeoJSON like input",(function(){var e=new L.Polygon([[[1,2],[3,4],[5,6]]]);expect(e.toGeoJSON().geometry).to.eql({type:"Polygon",coordinates:[[[2,1],[4,3],[6,5],[2,1]]]})})),it("returns a 3D MultiPolygon object from a simple GeoJSON like input",(function(){var e=new L.Polygon([[[1,2,3],[4,5,6],[7,8,9]]]);expect(e.toGeoJSON().geometry).to.eql({type:"Polygon",coordinates:[[[2,1,3],[5,4,6],[8,7,9],[2,1,3]]]})})),it("returns a 2D Polygon object (with holes)",(function(){var e=new L.Polygon([[[1,2],[3,4],[5,6]],[[7,8],[9,10],[11,12]]]);expect(e.toGeoJSON().geometry).to.eql({type:"Polygon",coordinates:[[[2,1],[4,3],[6,5],[2,1]],[[8,7],[10,9],[12,11],[8,7]]]})})),it("returns a 3D Polygon object (with holes)",(function(){var e=new L.Polygon([[[1,2,3],[4,5,6],[7,8,9]],[[10,11,12],[13,14,15],[16,17,18]]]);expect(e.toGeoJSON().geometry).to.eql({type:"Polygon",coordinates:[[[2,1,3],[5,4,6],[8,7,9],[2,1,3]],[[11,10,12],[14,13,15],[17,16,18],[11,10,12]]]})}))})),describe("L.Polygon (multi) #toGeoJSON",(function(){it("returns a 2D MultiPolygon object",(function(){var e=new L.Polygon([[[[1,2],[3,4],[5,6]]]]);expect(e.toGeoJSON().geometry).to.eql({type:"MultiPolygon",coordinates:[[[[2,1],[4,3],[6,5],[2,1]]]]})})),it("returns a 3D MultiPolygon object",(function(){var e=new L.Polygon([[[[1,2,3],[4,5,6],[7,8,9]]]]);expect(e.toGeoJSON().geometry).to.eql({type:"MultiPolygon",coordinates:[[[[2,1,3],[5,4,6],[8,7,9],[2,1,3]]]]})})),it("returns a 2D MultiPolygon object with two polygons",(function(){var e=new L.Polygon([[[[1,2],[3,4],[5,6]]],[[[7,8],[9,10],[11,12]]]]);expect(e.toGeoJSON().geometry).to.eql({type:"MultiPolygon",coordinates:[[[[2,1],[4,3],[6,5],[2,1]]],[[[8,7],[10,9],[12,11],[8,7]]]]})})),it("returns a 2D MultiPolygon object with polygon having a hole",(function(){var e=new L.Polygon([[[[1,2],[3,4],[5,6]],[[7,8],[9,10],[11,12]]]]);expect(e.toGeoJSON().geometry).to.eql({type:"MultiPolygon",coordinates:[[[[2,1],[4,3],[6,5],[2,1]],[[8,7],[10,9],[12,11],[8,7]]]]})}))})),describe("L.LayerGroup#toGeoJSON",(function(){it("returns a 2D FeatureCollection object",(function(){var e=new L.Marker([10,20]),t=new L.Polyline([[10,20],[2,5]]),o=new L.LayerGroup([e,t]);expect(o.toGeoJSON()).to.eql({type:"FeatureCollection",features:[e.toGeoJSON(),t.toGeoJSON()]})})),it("returns a 3D FeatureCollection object",(function(){var e=new L.Marker([10,20,30]),t=new L.Polyline([[10,20,30],[2,5,10]]),o=new L.LayerGroup([e,t]);expect(o.toGeoJSON()).to.eql({type:"FeatureCollection",features:[e.toGeoJSON(),t.toGeoJSON()]})})),it("ensures that every member is a Feature",(function(){var e=new L.TileLayer,t=new L.LayerGroup([e]);e.toGeoJSON=function(){return{type:"Point",coordinates:[20,10]}},expect(t.toGeoJSON()).to.eql({type:"FeatureCollection",features:[{type:"Feature",properties:{},geometry:{type:"Point",coordinates:[20,10]}}]})})),it("roundtrips GeometryCollection features",(function(){var e={type:"FeatureCollection",features:[{type:"Feature",geometry:{type:"GeometryCollection",geometries:[{type:"LineString",coordinates:[[-122.4425587930444,37.80666418607323],[-122.4428379594768,37.80663578323093]]},{type:"LineString",coordinates:[[-122.4425509770566,37.80662588061205],[-122.4428340530617,37.8065999493009]]}]},properties:{name:"SF Marina Harbor Master"}}]};expect(L.geoJSON(e).toGeoJSON()).to.eql(e)})),it("roundtrips MiltiPoint features",(function(){var e={type:"FeatureCollection",features:[{type:"Feature",geometry:{type:"MultiPoint",coordinates:[[-122.4425587930444,37.80666418607323],[-122.4428379594768,37.80663578323093]]},properties:{name:"Test MultiPoints"}}]};expect(L.geoJSON(e).toGeoJSON()).to.eql(e)})),it("omits layers which do not implement toGeoJSON",(function(){var e=new L.TileLayer,t=new L.LayerGroup([e]);expect(t.toGeoJSON()).to.eql({type:"FeatureCollection",features:[]})}))}));