describe("Polygon",(function(){var t=document.createElement("div");t.style.width="400px",t.style.height="400px";var n=new L.Map(t);n.setView(new L.LatLng(55.8,37.6),6),describe("#initialize",(function(){it("should never be flat",(function(){var t=new L.Polygon([[1,2],[3,4]]);expect(L.Polyline._flat(t._latlngs)).to.be(!1),expect(t.getLatLngs()).to.eql(t._latlngs)})),it("doesn't overwrite the given latlng array",(function(){var t=[[1,2],[3,4]],n=t.slice(),l=new L.Polygon(n);expect(n).to.eql(t),expect(l._latlngs).to.not.eql(n)})),it("can be called with an empty array",(function(){var t=new L.Polygon([]);expect(t._latlngs).to.eql([[]]),expect(t.getLatLngs()).to.eql(t._latlngs)})),it("can be initialized with holes",(function(){var t=new L.Polygon([[[0,10],[10,10],[10,0]],[[2,3],[2,4],[3,4]]]);expect(t._latlngs).to.eql([[L.latLng([0,10]),L.latLng([10,10]),L.latLng([10,0])],[L.latLng([2,3]),L.latLng([2,4]),L.latLng([3,4])]]),expect(t.getLatLngs()).to.eql(t._latlngs)})),it("can be initialized with multi including hole",(function(){var t=new L.Polygon([[[[10,20],[30,40],[50,60]]],[[[0,10],[10,10],[10,0]],[[2,3],[2,4],[3,4]]]]);expect(t._latlngs).to.eql([[[L.latLng([10,20]),L.latLng([30,40]),L.latLng([50,60])]],[[L.latLng([0,10]),L.latLng([10,10]),L.latLng([10,0])],[L.latLng([2,3]),L.latLng([2,4]),L.latLng([3,4])]]]),expect(t.getLatLngs()).to.eql(t._latlngs)})),it("can be added to the map when empty",(function(){var t=new L.Polygon([]).addTo(n);expect(n.hasLayer(t)).to.be(!0)}))})),describe("#isEmpty",(function(){it("should return true for a polygon with no latlngs",(function(){var t=new L.Polygon([]);expect(t.isEmpty()).to.be(!0)})),it("should return false for simple polygon",(function(){var t=new L.Polygon([[1,2],[3,4],[5,6]]);expect(t.isEmpty()).to.be(!1)})),it("should return false for a multi-polygon",(function(){var t=new L.Polygon([[[[10,20],[30,40],[50,60]]],[[[0,10],[10,10],[10,0]],[[2,3],[2,4],[3,4]]]]);expect(t.isEmpty()).to.be(!1)}))})),describe("#setLatLngs",(function(){it("doesn't overwrite the given latlng array",(function(){var t=[[1,2],[3,4]],n=t.slice();new L.Polygon(n).setLatLngs(n),expect(n).to.eql(t)})),it("can be set external ring and holes",(function(){var t=new L.Polygon([]);t.setLatLngs([[[0,10],[10,10],[10,0]],[[2,3],[2,4],[3,4]]]),expect(t.getLatLngs()).to.eql([[L.latLng([0,10]),L.latLng([10,10]),L.latLng([10,0])],[L.latLng([2,3]),L.latLng([2,4]),L.latLng([3,4])]])})),it("can be set multi including hole",(function(){var t=new L.Polygon([]);t.setLatLngs([[[[10,20],[30,40],[50,60]]],[[[0,10],[10,10],[10,0]],[[2,3],[2,4],[3,4]]]]),expect(t.getLatLngs()).to.eql([[[L.latLng([10,20]),L.latLng([30,40]),L.latLng([50,60])]],[[L.latLng([0,10]),L.latLng([10,10]),L.latLng([10,0])],[L.latLng([2,3]),L.latLng([2,4]),L.latLng([3,4])]]])}))})),describe("#getCenter",(function(){it("should compute center of a big simple polygon around equator",(function(){var t=new L.Polygon([[[0,0],[10,0],[10,10],[0,10]]]).addTo(n);expect(t.getCenter()).to.be.nearLatLng(L.latLng([5,5]),.1)})),it("should compute center of a small simple polygon",(function(){var t=new L.Polygon([[[0,0],[.01,0],[.01,.01],[0,.01]]]).addTo(n);n.setZoom(0),expect(t.getCenter()).to.be.nearLatLng(L.latLng([0,0]))})),it("throws error if not yet added to map",(function(){expect((function(){new L.Polygon([[[0,0],[10,0],[10,10],[0,10]]]).getCenter()})).to.throwException("Must add layer to map before using getCenter()")}))})),describe("#_defaultShape",(function(){it("should return latlngs on a simple polygon",(function(){var t=[L.latLng([1,2]),L.latLng([3,4])],n=new L.Polygon(t);expect(n._defaultShape()).to.eql(t)})),it("should return first latlngs on a polygon with hole",(function(){var t=[[L.latLng([0,12]),L.latLng([13,14]),L.latLng([15,16])],[L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]],n=new L.Polygon(t);expect(n._defaultShape()).to.eql(t[0])})),it("should return first latlngs on a multipolygon",(function(){var t=[[[L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]],[[L.latLng([11,12]),L.latLng([13,14]),L.latLng([15,16])]]],n=new L.Polygon(t);expect(n._defaultShape()).to.eql(t[0][0])})),it("should return first latlngs on a multipolygon with hole",(function(){var t=[[[L.latLng([0,10]),L.latLng([10,10]),L.latLng([10,0])],[L.latLng([2,3]),L.latLng([2,4]),L.latLng([3,4])]],[[L.latLng([10,20]),L.latLng([30,40]),L.latLng([50,60])]]],n=new L.Polygon(t);expect(n._defaultShape()).to.eql(t[0][0])}))})),describe("#addLatLng",(function(){it("should add latlng to latlngs",(function(){var t=new L.Polygon([[1,2],[3,4]]);t.addLatLng([5,6]),expect(t._latlngs).to.eql([[L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]])})),it("should add latlng to first latlngs on a polygon with hole",(function(){var t=new L.Polygon([[[0,12],[13,14],[15,16]],[[1,2],[3,4],[5,6]]]);t.addLatLng([17,0]),expect(t._latlngs[0]).to.eql([L.latLng([0,12]),L.latLng([13,14]),L.latLng([15,16]),L.latLng([17,0])]),expect(t._latlngs[1]).to.eql([L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])])})),it("should add latlng by reference on a polygon with hole",(function(){var t=new L.Polygon([[[0,12],[13,14],[15,16]],[[1,2],[3,4],[5,6]]]);t.addLatLng([7,8],t._latlngs[1]),expect(t._latlngs[0]).to.eql([L.latLng([0,12]),L.latLng([13,14]),L.latLng([15,16])]),expect(t._latlngs[1]).to.eql([L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6]),L.latLng([7,8])])})),it("should add latlng to first latlngs on a multi",(function(){var t=new L.Polygon([[[[1,2],[3,4]]],[[[11,12],[13,14],[15,16]]]]);t.addLatLng([5,6]),expect(t._latlngs[0]).to.eql([[L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]]),expect(t._latlngs[1]).to.eql([[L.latLng([11,12]),L.latLng([13,14]),L.latLng([15,16])]])})),it("should add latlng to latlngs by reference on a multi",(function(){var t=new L.Polygon([[[[11,12],[13,14],[15,16]]],[[[1,2],[3,4]]]]);t.addLatLng([5,6],t._latlngs[1][0]),expect(t._latlngs[1]).to.eql([[L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]]),expect(t._latlngs[0]).to.eql([[L.latLng([11,12]),L.latLng([13,14]),L.latLng([15,16])]])})),it("should add latlng on first latlngs by default on a multipolygon with hole",(function(){var t=new L.Polygon([[[[0,10],[10,10],[10,0]],[[2,3],[2,4],[3,4]]],[[[10,20],[30,40],[50,60]]]]);t.addLatLng([-10,-10]),expect(t._latlngs[0][0]).to.eql([L.latLng([0,10]),L.latLng([10,10]),L.latLng([10,0]),L.latLng([-10,-10])]),expect(t._latlngs[0][1]).to.eql([L.latLng([2,3]),L.latLng([2,4]),L.latLng([3,4])]),expect(t._latlngs[1][0]).to.eql([L.latLng([10,20]),L.latLng([30,40]),L.latLng([50,60])])})),it("should add latlng by reference on a multipolygon with hole",(function(){var t=new L.Polygon([[[[10,20],[30,40],[50,60]]],[[[0,10],[10,10],[10,0]],[[2,3],[2,4],[3,4]]]]);t.addLatLng([2,2],t._latlngs[1][1]),expect(t._latlngs[0][0]).to.eql([L.latLng([10,20]),L.latLng([30,40]),L.latLng([50,60])]),expect(t._latlngs[1][0]).to.eql([L.latLng([0,10]),L.latLng([10,10]),L.latLng([10,0])]),expect(t._latlngs[1][1]).to.eql([L.latLng([2,3]),L.latLng([2,4]),L.latLng([3,4]),L.latLng([2,2])])}))}))}));