describe("Polyline",(function(){var t=document.createElement("div");t.style.width="400px",t.style.height="400px";var e=new L.Map(t);e.setView(new L.LatLng(55.8,37.6),6),describe("#initialize",(function(){it("doesn't overwrite the given latlng array",(function(){var t=[[1,2],[3,4]],e=t.slice(),n=new L.Polyline(e);expect(e).to.eql(t),expect(n._latlngs).to.not.eql(e),expect(n.getLatLngs()).to.eql(n._latlngs)})),it("should accept a multi",(function(){var t=new L.Polyline([[[1,2],[3,4],[5,6]],[[11,12],[13,14],[15,16]]]);expect(t._latlngs[0]).to.eql([L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]),expect(t._latlngs[1]).to.eql([L.latLng([11,12]),L.latLng([13,14]),L.latLng([15,16])]),expect(t.getLatLngs()).to.eql(t._latlngs)})),it("should accept an empty array",(function(){var t=new L.Polyline([]);expect(t._latlngs).to.eql([]),expect(t.getLatLngs()).to.eql(t._latlngs)})),it("can be added to the map when empty",(function(){var t=new L.Polyline([]).addTo(e);expect(e.hasLayer(t)).to.be(!0)}))})),describe("#isEmpty",(function(){it("should return true for a polyline with no latlngs",(function(){var t=new L.Polyline([]);expect(t.isEmpty()).to.be(!0)})),it("should return false for simple polyline",(function(){var t=new L.Polyline([[1,2],[3,4]]);expect(t.isEmpty()).to.be(!1)})),it("should return false for multi-polyline",(function(){var t=new L.Polyline([[[1,2],[3,4]],[[11,12],[13,14]]]);expect(t.isEmpty()).to.be(!1)}))})),describe("#setLatLngs",(function(){it("doesn't overwrite the given latlng array",(function(){var t=[[1,2],[3,4]],e=t.slice();new L.Polyline(e).setLatLngs(e),expect(e).to.eql(t)})),it("can be set a multi",(function(){var t=new L.Polyline([]);t.setLatLngs([[[1,2],[3,4],[5,6]],[[11,12],[13,14],[15,16]]]),expect(t._latlngs[0]).to.eql([L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]),expect(t._latlngs[1]).to.eql([L.latLng([11,12]),L.latLng([13,14]),L.latLng([15,16])])}))})),describe("#getCenter",(function(){it("should compute center of a big flat line on equator",(function(){var t=new L.Polyline([[0,0],[0,90]]).addTo(e);expect(t.getCenter()).to.eql(L.latLng([0,45]))})),it("should compute center of a big flat line close to the pole",(function(){var t=new L.Polyline([[80,0],[80,90]]).addTo(e);expect(t.getCenter()).to.be.nearLatLng(L.latLng([80,45]),.01)})),it("should compute center of a big diagonal line",(function(){var t=new L.Polyline([[0,0],[80,80]]).addTo(e);expect(t.getCenter()).to.be.nearLatLng(L.latLng([57,40]),1)})),it("should compute center of a diagonal line close to the pole",(function(){var t=new L.Polyline([[70,70],[84,84]]).addTo(e);expect(t.getCenter()).to.be.nearLatLng(L.latLng([79,77]),1)})),it("should compute center of a big multiline",(function(){var t=new L.Polyline([[10,-80],[0,0],[0,10],[10,90]]).addTo(e);expect(t.getCenter()).to.be.nearLatLng(L.latLng([0,5]),1)})),it("should compute center of a small flat line",(function(){var t=new L.Polyline([[0,0],[0,.09]]).addTo(e);e.setZoom(0),expect(t.getCenter()).to.be.nearLatLng(L.latLng([0,0]),.01)})),it("throws error if not yet added to map",(function(){expect((function(){new L.Polyline([[0,0],[0,.09]]).getCenter()})).to.throwException("Must add layer to map before using getCenter()")}))})),describe("#_flat",(function(){L.polyline([]);it("should return true for an array of LatLngs",(function(){expect(L.Polyline._flat([L.latLng([0,0])])).to.be(!0)})),it("should return true for an array of LatLngs arrays",(function(){expect(L.Polyline._flat([[0,0]])).to.be(!0)})),it("should return true for an empty array",(function(){expect(L.Polyline._flat([])).to.be(!0)})),it("should return false for a nested array of LatLngs",(function(){expect(L.Polyline._flat([[L.latLng([0,0])]])).to.be(!1)})),it("should return false for a nested empty array",(function(){expect(L.Polyline._flat([[]])).to.be(!1)}))})),describe("#_defaultShape",(function(){it("should return latlngs when flat",(function(){var t=[L.latLng([1,2]),L.latLng([3,4])],e=new L.Polyline(t);expect(e._defaultShape()).to.eql(t)})),it("should return first latlngs on a multi",(function(){var t=[[L.latLng([1,2]),L.latLng([3,4])],[L.latLng([11,12]),L.latLng([13,14])]],e=new L.Polyline(t);expect(e._defaultShape()).to.eql(t[0])}))})),describe("#addLatLng",(function(){it("should add latlng to latlngs",(function(){var t=new L.Polyline([[1,2],[3,4]]);t.addLatLng([5,6]),expect(t._latlngs).to.eql([L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])])})),it("should add latlng to first latlngs on a multi",(function(){var t=new L.Polyline([[[1,2],[3,4]],[[11,12],[13,14]]]);t.addLatLng([5,6]),expect(t._latlngs[0]).to.eql([L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]),expect(t._latlngs[1]).to.eql([L.latLng([11,12]),L.latLng([13,14])])})),it("should add latlng to latlngs by reference",(function(){var t=new L.Polyline([[[11,12],[13,14]],[[1,2],[3,4]]]);t.addLatLng([5,6],t._latlngs[1]),expect(t._latlngs[1]).to.eql([L.latLng([1,2]),L.latLng([3,4]),L.latLng([5,6])]),expect(t._latlngs[0]).to.eql([L.latLng([11,12]),L.latLng([13,14])])})),it("should add latlng on empty polyline",(function(){var t=new L.Polyline([]);t.addLatLng([1,2]),expect(t._latlngs).to.eql([L.latLng([1,2])])}))}))}));